import { Interceptor } from '@zeedhi/core';

Interceptor.addRequestSuccess((config) => {
	const token = localStorage.getItem('LOGIN_TOKEN');
	if (token && currentPage() !== 'autenticacao') {
		config.headers['OAuth-Token'] = token;
	}
	return config;
});

function currentPage() {
	if (process.env.NODE_ENV === 'production') {
		const routeParams = JSON.parse(<string>localStorage.getItem('routeParams'));
		return routeParams.page;
	}
	const { searchParams } = new URL(window.location.href);
	return searchParams.get('page') || '';
}
